package com.lightinit.hsdatashow.impl.ms;

import com.lightinit.hsdatashow.entity.*;
import com.lightinit.hsdatashow.mapper.AgeStructureMapper;
import com.lightinit.hsdatashow.mapper.DependencyRatioMapper;
import com.lightinit.hsdatashow.model.ResultState;
import com.lightinit.hsdatashow.model.ResultStateCode;
import com.lightinit.hsdatashow.service.ms.IMSAgeStructureService;
import com.lightinit.hsdatashow.service.ms.IMSDependencyRatioService;
import com.lightinit.hsdatashow.spring.DynamicDataContextHolder;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class MSDependencyRatioServiceImpl implements IMSDependencyRatioService {
    @Autowired
    private DependencyRatioMapper dependencyRatioMapper;
    @Override
    public List<DependencyRatio> queryList(BaseExample.Page pager) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        DependencyRatioExample example = new DependencyRatioExample();
        example.setPage(pager);
        return dependencyRatioMapper.selectByExample(example);
    }

    @Override
    public long queryCount(BaseExample.Page pager) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        DependencyRatioExample example = new DependencyRatioExample();
        example.setPage(pager);
        return dependencyRatioMapper.countByExample(example);
    }

    @Override
    public ResultState<Long> delete(long id) {
        ResultState<Long> resultState = new ResultState<Long>();
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        if (!(dependencyRatioMapper.deleteByPrimaryKey(id)>0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据不存在");
        }
        resultState.setData(id);
        return resultState;
    }

    @Override
    public ResultState add(DependencyRatio inputModel) {
        ResultState<Long> resultState = new ResultState<Long>();
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        inputModel.setCreatedAt(new Date());
        DependencyRatio entity = new DependencyRatio();
        BeanUtils.copyProperties(inputModel, entity);
        long sqlResult = dependencyRatioMapper.insert(entity);
        if (!(sqlResult > 0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据插入失败");
        }
        resultState.setData(entity.getId());
        return resultState;
    }

    @Override
    public DependencyRatio edit(long id) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        return dependencyRatioMapper.selectByPrimaryKey(id);
    }

    @Override
    public ResultState doEdit(DependencyRatio inputModel) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        ResultState<Long> resultState = new ResultState<Long>();
        if (!(dependencyRatioMapper.updateByPrimaryKey(inputModel)>0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据不存在");
        }
        resultState.setData(inputModel.getId());
        return resultState;
    }
}
